#include <locale.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include "gdbm.h"
#include <string.h>
#include <limits.h>
#include "curses.h"

#include "struktury.h"
#include "struktury_dbm.h"
#include "lib.h"
#include "lib_dbm.h"

menu_options menu (void);
void zaznam_novy (DBM *); // TODO: presunout do zaznam/zaznam.h a tady includovat, pouzit zaznam.h v zaznam/ ...
void zaznam_editace (DBM *);

int
main (void)
{
  DBM *dbm_ptr;
  char databaze[NAME_MAX];
  menu_options menu_navrat;
  short f,b;

  if (pbadresar (ADRZNAMKY))
    {
      fprintf (stderr, "Nelze otevrit adresar");
      exit (1);
    }

  if ((setlocale(LC_ALL, "") == NULL))
  {
    fprintf (stderr, "Nelze inicializovat locales.");
    exit(1);
  }

  strcpy (databaze, jmeno_adr (ADRZNAMKY));
  strcat (databaze, JMDATA);

  if (!(dbm_ptr = dbm_open (databaze, O_RDWR | O_CREAT, 0666)))
    {
      fprintf (stderr, "Nelze otevrit databazi %s\n", databaze);
      exit (1);
    }

  initscr ();
  if(LINES < 25 || COLS < 80) { // TODO: kontrolovat porad, nejen pri spusteni programu
      endwin ();
      dbm_close (dbm_ptr);
      fprintf (stderr, "Rozmery obrazovky jsou prilis male (pozaduji 80x25)!\n");
      exit(1);
  }
  if (!has_colors ())
    {
      endwin ();
      dbm_close (dbm_ptr);
      fprintf (stderr, "Nelze inicializovat barvy (curses)!\n");
      exit(1);
    }

  start_color ();
  use_default_colors();

  init_pair (CERVENA, COLOR_RED, -1);
  init_pair (ZELENA, COLOR_GREEN, -1);
  init_pair (SVETLEM, COLOR_CYAN, -1);
  init_pair (MENU, COLOR_BLUE, COLOR_WHITE);
  init_pair (ZELZLUT, COLOR_GREEN, COLOR_CYAN);

  init_pair (FIALOVA, COLOR_MAGENTA, -1);

  noecho ();
  keypad (stdscr, TRUE);        /* spracovani KEY_ sekvenci */
  do
    {
      clear ();
      mvprintw (1, 1, "<< (c) www.sallyx.org >>");
      mvprintw (2, 1, "ver %s   2002-2010",VER);

      mvprintw (15, 5, "Mini HELP: Program ukončíte klávesou F10");
      mvprintw (LINES - 2, (int) COLS / 2 - 20,
        	"<<-_-_-_-_-_-_-_-_%03ix%03i_-_-_-_-_-_-_-_->>",COLS, LINES);
      refresh ();

      menu_navrat = menu ();

      switch (menu_navrat)
        {
        case men_novy:
          zaznam_novy (dbm_ptr);
          break;
        case men_editace:
          zaznam_editace (dbm_ptr);
          break;
        case mens_prumer:
          prumer (dbm_ptr);
          break;
        case mens_kreditu:
          kreditu (dbm_ptr);
          break;
        case mens_25:
          hranice25 (dbm_ptr);
          break;
        case mens_udelano:
          udelano (dbm_ptr);
          break;
        case ment_semestr:
          trideni_semestr (dbm_ptr);
          break;
        case ment_vsemestru:
          trideni_vsemestru (dbm_ptr);
          break;
        case ment_znamka:
          trideni_znamka (dbm_ptr);
          break;
        case men_esc:
        default:
          break;
        }
    }
  while (menu_navrat != men_konec);

  echo ();
  endwin ();
  dbm_close (dbm_ptr);
  return 0;
}
