#include <curses.h>
#include <memory.h>
#include "../gdbm.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

#define HORN 4

void
trideni_znamka (DBM * dbm_ptr)
{
  struct zaznam nacteno;
  struct dbm_info informace;
  WINDOW *pad;
  datum klic;
  datum data;
  int klavesa, i;
  int ukazatel;

  informace = zjisti_informace (dbm_ptr);

  pad = newpad (informace.poc_zaznamu + 4 * 3, COLS);

  erase ();
  printw ("Čekejte ...");
  refresh ();

  for (i = 0; i < 4; i++)
    {

      wattron(pad,COLOR_PAIR(3));
      if (i)
        wprintw (pad, "Známka: %i\n", i);
      else
        wprintw (pad, "Neznámkované předměty:\n");

      wprintw (pad, "%-*s\n", COLS - 1, "-----------------------------");
      wattroff(pad,COLOR_PAIR(3));

      for (klic = dbm_firstkey (dbm_ptr); klic.dptr;
           klic = dbm_nextkey (dbm_ptr))
        {
          data = dbm_fetch (dbm_ptr, klic);
          memcpy (&nacteno, data.dptr, data.dsize);

          if (nacteno.znamka == i)
            {
              if (!nacteno.vsemestru)
                wattron (pad, A_BOLD);
              wprintw8 (pad, L"%4s %-40s %4i %5i %6i \n",
                       nacteno.kod, nacteno.nazev, nacteno.semestr,
                       nacteno.vsemestru, nacteno.kreditu);
              if (!nacteno.vsemestru)
                wattroff (pad, A_BOLD);
            }
        }
        wprintw(pad,"\n");
    }

  erase ();
  mvprintw (0, 0, "BACKSPACE nebo F10 = konec;");
  mvprintw (1, 0, "%i záznamů.\n", informace.poc_zaznamu);
  mvprintw8 (2, 0, L"%4s %-40s %5s %6s %6s", "kód:", "Název", "sem.",
            "v sem.", "kredit");
  refresh ();

  ukazatel = 0;
  i = informace.poc_zaznamu + 4 * 3 - (LINES - 1 - HORN);
  do
    {
      prefresh (pad, ukazatel, 0, HORN, 0, LINES - 1, COLS - 1);
      klavesa = getch ();
      switch (klavesa)
        {
        case ' ':
        case KEY_DOWN:
          if (ukazatel < i - 1)
            ukazatel++;
          break;
        case KEY_UP:
          if (ukazatel > 0)
            ukazatel--;
          break;
        default:
          break;
        }
    }
  while (klavesa != KEY_BACKSPACE && klavesa != KEY_F(10));

  delwin (pad);
}
