/*------------------------------------------------*/
/* 22process/shmap_destroy.c                      */

#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <errno.h>
#include "shmap.h"

int main(void) {
    int segment_id; /* identifikace zdilene pameti     */
    int ret;

    segment_id = shmget(SKEY, sizeof(char)*N,
             S_IRUSR | S_IWUSR);
    if(segment_id < 0) {
        if(errno == ENOENT) {
            fprintf(stderr,"Segment s key = %i neexistuje.\n", SKEY);
            return 0;
        }
        fprintf(stderr,"Nějaká chyba získávání segmentu.");
        return 1;
    }
    ret = shmctl(segment_id, IPC_RMID, NULL);
    if(ret < 0) {
        fprintf(stderr,"Nějaká chyba mazání segmentu.");
        return 1;
    }
    fprintf(stderr,"Segment s key = %i byl smazán.\n", SKEY);
    return 0;
}

/*------------------------------------------------*/
