/*------------------------------------------------*/
/* 22process/shmap_use.c                          */

#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <errno.h>
#include <getopt.h>
#include <string.h>
#include "shmap.h"

int main(int argc, char *argv[]) {
    int segment_id; /* identifikace zdilene pameti     */
    char *pole;
    char *retezec = NULL;
    char *optstring ="+t:";
    int op;
    do {
        op = getopt(argc, argv, optstring);
        switch(op) {
            case -1:  break;
            case '?': /* getopt vypise chybu*/ break;
            case 't': retezec = optarg; break;
        }
    } while (op != -1);

    if(retezec == NULL) {
        fprintf(stderr,"Užití: %s -t \"retezec\"\n", argv[0]);
        return 1;
    }
    /* zajimava cast zacina zde: */
    segment_id = shmget(SKEY, sizeof(char)*N,
             S_IRUSR | S_IWUSR);
    if(segment_id < 0) {
        if(errno == ENOENT) {
            fprintf(stderr,"Segment s key = %i neexistuje.\n", SKEY);
            return 1;
        }
        fprintf(stderr, "Něco je špatně.\n");
        return 1;
    }
    pole = (char *) shmat(segment_id, NULL, 0);
    strncpy(pole, retezec, N-1);
    shmdt(pole);

    return 0;
}

/*------------------------------------------------*/
