/*------------------------------------------------*/
/* 23processKomunikace/pipe2.c                    */

#include <unistd.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>

#define N 512

int main(int argc, char *argv[])
{
    pid_t pid;
    int pipefdin[2];
    int pipefdout[2];
    char *filter;
    char buff[N];
    int i;

    if (argc < 3) {
        fprintf(stderr, "Usage: %s filter word [word, ...]\n", argv[0]);
        return 0;
    }
    filter = argv[1];

    if (pipe(pipefdin) != 0 || pipe(pipefdout) != 0) {
        perror("pipe");
        exit(EXIT_FAILURE);
    }

    pid = fork();
    if (pid < 0) {
        perror("fork");
        exit(EXIT_FAILURE);
    }
    if (pid == 0) {
        dup2(pipefdin[0], STDIN_FILENO);
        close(pipefdin[0]);
        close(pipefdin[1]);
        dup2(pipefdout[1], STDOUT_FILENO);
        close(pipefdout[0]);
        close(pipefdout[1]);
        execlp("grep", "grep", filter, NULL);
        /* execlp ukonci process */
        /* Kdyz ne, je to chyba */
        perror("execlp");
        exit(EXIT_FAILURE);
    }
    /** rodic **/
    close(pipefdin[0]);
    close(pipefdout[1]);

    pid = fork();
    if (pid < 0) {
        perror("fork");
        exit(EXIT_FAILURE);
    }
    if (pid == 0) {
        close(pipefdout[0]);
        for (i = 2; i < argc; i++) {
            write(pipefdin[1], argv[i], strlen(argv[i]));
            write(pipefdin[1], "\n", strlen("\n"));
        }
        close(pipefdin[1]);
    } else {
        close(pipefdin[1]);
        do {
            i = read(pipefdout[0], buff, N - 1);
            if (!i)
                break;
            buff[i] = '\0';
            printf("Prošlo filtrem:\n%s", buff);
        }
        while (i);
        close(pipefdout[0]);
    }

    return 0;
}

/*------------------------------------------------*/
