/*------------------------------------------------*/
/* 24threads/threads1.c                           */

#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdio.h>
#include <err.h>
#include <string.h> /* kvuli strerror() */

void *producent(void * arg) {
    int i;
    int *pipe = (int *)arg;
    printf("Producent start\n");
    for (i = 0; i <= 5; i++) {
        write(pipe[1], &i, sizeof(i));
    }
    close(pipe[1]);
    printf("Producent konec\n");
    return NULL;
}

void *consumer(void * arg) {
    ssize_t readed;
    int i;
    int *pipe = (int *)arg;
    printf("Consumer start\n");
    do {
        readed = read(pipe[0],&i, sizeof(i));
        if(readed != sizeof(i)) break;
        printf("Načteno %i\n",i);
    } while(true);
    close(pipe[0]);
    printf("Consumer konec\n");
    return NULL;
}

int main(void) {
    pthread_t producent_t, consumer_t;
    int pipefd[2], err;
    
    if(pipe(pipefd) != 0) {
        perror("pipe");
        exit(EXIT_FAILURE);
    }

    err = pthread_create(&producent_t,NULL,producent,(void *)pipefd);
    if(err) {
        errx(1, "pthread_create producent %s\n",strerror(err));
        exit(EXIT_FAILURE);
    }
    err = pthread_create(&consumer_t,NULL,consumer,(void *)pipefd);
    if(err) {
        errx(1, "pthread_create consumer %s\n",strerror(err));
        exit(EXIT_FAILURE);
    }
    pthread_detach(producent_t);
    pthread_join(consumer_t, NULL);
    printf("main konec\n");
    return 0;
}

/*------------------------------------------------*/
