/*------------------------------------------------*/
/* 27aDom/dom.c                                   */

#include <stdio.h>
#include "config.h"
#include "dom-parser.h"

int main(void)
{
    xmlDocPtr doc;
    xmlNodePtr cur;
    Config *config = createConfigStructure(2);
    if (!config) {
        fprintf(stderr, "Nepodařilo se vytvořit Config\n");
        return 1;
    }

    doc = xmlParseFile("config.xml");
    if (doc == NULL) {
        fprintf(stderr, "Document se nepodařilo naparsovat.\n");
        return 1;
    }

    cur = xmlDocGetRootElement(doc);
    if (cur == NULL) {
        fprintf(stderr, "Prázdný dokument\n");
        xmlFreeDoc(doc);
        return 1;
    }

    parseConfigDocument(doc, cur, config);

    printConfigStructure(config);
    freeConfigStructure(config);
    /* xmlSaveFile("-", doc); // */
    xmlFreeDoc(doc);
    return 0;
}

/*------------------------------------------------*/
