/*------------------------------------------------*/
/* 27bSax/config.h                                */

#ifndef _CONFIG_H
#define _CONFIG_H
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

typedef struct {
    char major[3];
    char minor[5];
} Version;

enum databaseType {
    unknown = 0, mysql, postgres, oracle, sqlite
};

typedef struct {
    enum databaseType type;
    bool enabled;
    char name[32];
    char password[32];
    char schema[32];
    char host[32];
    int port;
} Database;

typedef struct {
    Version version;
    Database *databases;
    size_t databasesSize;
} Config;

enum databaseType getDatabaseTypeFromText(char *type);
int getDefaultPort(enum databaseType type);
Config *createConfigStructure(size_t databases);
void freeConfigStructure(Config * config);
void printConfigStructure(Config * config);
#endif

/*------------------------------------------------*/
