/*------------------------------------------------*/
/* 27cDtd/dtd.h                                   */
#include <stdio.h>
#include <libxml/parser.h>
#include <libxml/valid.h>

void onWarning(void * ctx, const char * msg, ...) {
    va_list ap;
    va_start(ap, msg);
    printf("WARNING: ");
    vprintf(msg, ap);
    printf("****\n");
    va_end(ap);
}

void onError(void * ctx, const char * msg, ...) {
    va_list ap;
    va_start(ap, msg);
    printf("ERROR: ");
    vprintf(msg, ap);
    printf("****\n");
    va_end(ap);
}

int main(void) {
    xmlDocPtr doc;
    xmlValidCtxtPtr ctxt = xmlNewValidCtxt();
    int valid;
    ctxt->error = onError;
    ctxt->warning = onWarning;
    doc = xmlParseFile("config.xml");
    if (doc == NULL) {
        fprintf(stderr, "Document se nepodařilo naparsovat.\n");
        return 1;
    }
    
   valid = xmlValidateDocument(ctxt, doc);
   if(valid)
        printf("Document je validní.\n");
   else
        printf("Dokument není validní.\n");
   

   xmlFreeValidCtxt(ctxt);
   return 0;
}
/*------------------------------------------------*/
