/*------------------------------------------------*/
/* 28dbm/ndbm.c                                   */

#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "xdbm.h"

#define ULOZISTE "uloziste"
#define MAX_LEN 512
#define POLOZEK 4

struct text {
    int id;
    char text[MAX_LEN];
};

void printResult(datum * key, datum * result);

int main(void)
{
    DBM *dbm;
    datum key;
    datum content;
    datum result;
    int i;
    struct text polozka;
    char *klice[POLOZEK] = { "1", "2", "3", "3" };
    char *texty[POLOZEK] = { "jedna", "dva", "tři", "čtyři" };

    /* otevreni database */
    dbm = dbm_open(ULOZISTE, O_CREAT | O_RDWR, S_IRUSR | S_IWUSR);
    if (!dbm) {
        perror("dbm_open");
        return 1;
    }

    /* ulozeni polozek */
    for (i = 0; i < POLOZEK; i++) {
        key.dptr = (void *)klice[i];
        key.dsize = strlen(klice[i]) + 1;

        polozka.id = i + 1;
        strncpy(polozka.text, texty[i], MAX_LEN - 1);
        polozka.text[MAX_LEN-1] = '\0';

        content.dptr = (void *)&polozka;
        content.dsize = sizeof(polozka.id) + strlen(polozka.text) + 1;

        if (dbm_store(dbm, key, content, DBM_INSERT)) {
            perror("dbm_store");
        }
    }

    /* nacteni a vypsani polozky "3" */
    key.dptr = (void *)"3";
    key.dsize = 2;        /* '3' a '\0' */
    result = dbm_fetch(dbm, key);
    printResult(&key, &result);
    /* nacteni a vypsani polozky "4" */
    key.dptr = (void *)"4";
    key.dsize = 2;        /* '3' a '\0' */
    result = dbm_fetch(dbm, key);
    printResult(&key, &result);

    /* nacteni a vypsani vsech polozek */
    printf("***\n");
    for (key = dbm_firstkey(dbm); key.dptr != NULL; key = dbm_nextkey(dbm)) {
        result = dbm_fetch(dbm, key);
        printResult(&key, &result);
    }

    dbm_close(dbm);

    return 0;
}

/**
* Zkontroluje, zda neni result prazdny
* a pak jej vytiskne.
*/
void printResult(datum * key, datum * result)
{
    struct text r;

    if (!result->dptr) {
        fprintf(stderr, "polozka[%s]: ", (char *)key->dptr);
        perror(NULL);
        return;
    }
    memcpy(&r, result->dptr, result->dsize);
    printf("polozka[%s]: [%i, %s]\n", (char *)key->dptr, r.id, r.text);
}

/*------------------------------------------------*/
