/*------------------------------------------------*/
/* 29postgresql/select2.c                         */
#include <libpq-fe.h>
#include <string.h>
#include "pg-utils.h"

int main(int argc, char **argv)
{
    PGresult *res;
    ExecStatusType status;
    PGconn *conn = pgconnect(argc, argv);
    if (conn == NULL) {
        return 1;
    }
    printf("Conection OK\n");

    /* SELECT */
    const char *values[] = { "1" };
    res = PQexecParams(conn,
               "SELECT * FROM databases WHERE config_id = $1",
               1, NULL, values, NULL, NULL, 0);
    status = printStatus(res);
    if (status != PGRES_TUPLES_OK) {
        return 1;
    }

    /* PRINT info */
    int r, c, t, f;
    r = PQntuples(res);    /* pocet radek */
    c = PQnfields(res);    /* pocet sloupcu */
    printf("\n");
    printf("position\tname\t\ttype\tsize\n");
    for (f = 0; f < c; f++) {
        printf("%8i", f);
        printf("\t%-10s", PQfname(res, f));
        printf("\t%s", getTypeName(conn, res, f));
        printf("\t%4i", PQfsize(res, f));
        printf("\n");
    }

    for (t = 0; t < r; t++) {
        for (f = 0; f < c; f++) {
            printf("[%i,%i]: %-10s = ", t, f, PQfname(res, f));
            if (PQgetisnull(res, t, f)) {
                printf("<NULL>");
            } else {
                printf("%s", PQgetvalue(res, t, f));
            }
            printf("\n");
        }
    }

    PQclear(res);
    PQfinish(conn);
    return 0;
}

/*------------------------------------------------*/
