/*------------------------------------------------*/
/* 40socket/connection-socket.c                   */
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdbool.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include "connection.h"

#define SOCKET_FILE "/tmp/socket_file_example1"

static int server_fd = -1;

bool startServer(void)
{
    struct sockaddr_un server_address;
    int ret;
    server_fd = socket(AF_UNIX, SOCK_STREAM, 0);
    if (server_fd < 0) {
        perror("socket");
        return false;
    }
    server_address.sun_family = AF_UNIX;
    strcpy(server_address.sun_path, SOCKET_FILE);
    ret = bind(server_fd, (struct sockaddr *)&server_address,
           sizeof(server_address));
    if (ret < 0) {
        perror("bind");
        return false;
    }
    listen(server_fd, 5);
    return true;
}

void stopServer(void)
{
    unlink(SOCKET_FILE);
}

descriptors waitForClientConnection(void)
{
    descriptors fd = { -1, -1 };
    struct sockaddr_un client_address;
    int client_fd;
    socklen_t client_len;
    memset(&client_address, 0, sizeof(client_address));
    client_len = sizeof(client_address);
    client_fd =
        accept(server_fd, (struct sockaddr *)&client_address, &client_len);
    fd.r = fd.w = client_fd;
    return fd;
}

void closeClientConnection(descriptors * fd)
{
    if (fd->r >= 0) {
        if (close(fd->r) < 0) {
            perror("close r");
        }
    }
    fd->r = fd->w = -1;
}

descriptors connectClientToServer(void)
{
    struct sockaddr_un address;
    int sockfd;
    int ret;
    descriptors fd = { -1, -1 };

    sockfd = socket(AF_UNIX, SOCK_STREAM, 0);
    if (sockfd < 0) {
        perror("socket");
        return fd;
    }

    memset(&address, 0, sizeof(address));
    address.sun_family = AF_UNIX;
    strcpy(address.sun_path, SOCKET_FILE);
    ret = connect(sockfd, (struct sockaddr *)&address, sizeof(address));
    if (ret < 0)
        perror("connect");
    fd.r = fd.w = sockfd;

    return fd;
}

void disconnectClientFromServer(descriptors * fd)
{
    if (close(fd->r) < 0) {
        perror("close r");
    }
}
/*------------------------------------------------*/
