/*------------------------------------------------*/
/* 40socket/server.c                              */
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include "connection.h"

static descriptors fd = { -1, -1 };

static void closeServerHandler()
{
    printf("\nClosing server ...\n");
    closeClientConnection(&fd);
    stopServer();
    exit(EXIT_SUCCESS);
}

int main(void)
{
    if (!startServer())
        exit(EXIT_FAILURE);
    signal(SIGINT, closeServerHandler);

    while (1) {
        printf("Čekám na připojení od klienta ...\n");
        fd = waitForClientConnection();
        if (fd.r < 0 || fd.w < 0) {
            fprintf(stderr, "Connection failed.\n");
            stopServer();
            exit(EXIT_FAILURE);
        }
        serverWork(&fd);
        closeClientConnection(&fd);
    }

    return 0;
}
/*------------------------------------------------*/
