#include <memory.h>
#include <curses.h>
#include "../gdbm.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

int
smaz_zaznam (DBM * dbm_ptr, int ukazatel)
{
  struct zaznam nacteno;
  datum klic;
  datum data;
  WINDOW *new_win;
  int i = 0;


  for (klic = dbm_firstkey (dbm_ptr); klic.dptr; klic = dbm_nextkey (dbm_ptr))
    {
      if (i == ukazatel)
	{
	  data = dbm_fetch (dbm_ptr, klic);
	  memcpy (&nacteno, data.dptr, data.dsize);
	  break;
	}
      i++;
    }
  if (i != ukazatel)
    return 1;

  new_win = newwin (4, COLS, (int) LINES / 2 - 1, 0);
  box (new_win, ACS_VLINE, ACS_HLINE);
  mvwprintw (new_win, 0, 2, " DELETE ");
  mvwprintw (new_win, 1, 1, "%4s %-40s %5i %5i %6i %6i", nacteno.kod,
	     nacteno.nazev, nacteno.semestr, nacteno.vsemestru,
	     nacteno.kreditu, nacteno.znamka);
  clear ();
  refresh ();
  do
    {
      mvwprintw (new_win, 2, 1, "Smazat [Ano,Ne] ?");
      wrefresh (new_win);
      switch (getch ())
	{
	case 'n':
	case 'N':
	  delwin (new_win);
	  return 0;
	  break;
	case 'a':
	case 'A':
	  data.dsize = strlen (nacteno.kod);
	  if (dbm_delete (dbm_ptr, data))
	    {
	      fprintf (stderr, "Erorr mazani z databaze\n");
	      return 1;
	    }
	  else
	    return 0;
	  break;
	}
    }
  while (1);

  delwin (new_win);
  return 0;
}
