#include <string.h>
#include "../gdbm.h"
#include "../struktury_dbm.h"
#include "../curses.h"
#include "../struktury.h"
#include "../lib.h"

#define HORZ '$'
#define VERT '#'

void
zaznam_novy (DBM * dbm_ptr)
{
  WINDOW *sub_win;
  struct zaznam pomocny;

  sub_win = subwin (stdscr, LINES, COLS, 0, 0);

znovu:
  wclear (sub_win);
  box (sub_win, HORZ, VERT);
  echo ();

  wattron (sub_win, COLOR_PAIR (CERVENA));
  mvwprintw8 (sub_win, 5, 4, L"%-27s", "Zadejte KÓD předmětu: ");
  wattroff (sub_win, COLOR_PAIR (CERVENA));
  wrefresh (sub_win);
  wgetnstr (sub_win, pomocny.kod, sizeof (pomocny.kod) / sizeof (char) - 1);

  if (!strcmp (pomocny.kod, ""))
    {
      wprintw (sub_win, "\n\tZadali jste prázdný kód!");
      wrefresh (sub_win);
      sleep (2);
      delwin (sub_win);
      return;
    }

  velka_pismena (pomocny.kod);

  wattron (sub_win, COLOR_PAIR (CERVENA));
  mvwprintw8 (sub_win, 6, 4, L"%-27s", "Zadejte NÁZEV předmětu: ");
  wattroff (sub_win, COLOR_PAIR (CERVENA));
  wrefresh (sub_win);
  wgetnstr (sub_win, pomocny.nazev, sizeof (pomocny.nazev) / sizeof (char) - 1);

  if (!strcmp (pomocny.nazev, ""))
    {
      wprintw (sub_win, "\n\tNezadali jste název předmětu !");
      wrefresh (sub_win);
      sleep (2);
      delwin (sub_win);
      return;
    }


  do
    {
      wattron (sub_win, COLOR_PAIR (CERVENA));
      mvwprintw8 (sub_win, 7, 4, L"%-27s", "Počet KREDITů: ");
      wattroff (sub_win, COLOR_PAIR (CERVENA));
      wclrtoeol (sub_win);
      box (sub_win, HORZ, VERT);
      wrefresh (sub_win);
      if(0 >= wscanw (sub_win, "%i", &pomocny.kreditu))
      {
        pomocny.kreditu = -1;
      }
    }
  while (pomocny.kreditu < 0 || pomocny.kreditu > 100);


  do
    {
      wattron (sub_win, COLOR_PAIR (CERVENA));
      mvwprintw8 (sub_win, 8, 4, L"%-27s", "ZNÁMKA (0 = neznámkováno): ");
      wattroff (sub_win, COLOR_PAIR (CERVENA));
      wclrtoeol (sub_win);
      box (sub_win, HORZ, VERT);
      wrefresh (sub_win);
      if(0 >= wscanw (sub_win, "%i", &pomocny.znamka))
      {
        pomocny.znamka = -1;
      }
    }
  while ((pomocny.znamka < 0 || pomocny.znamka > 3));


  do
    {
      wattron (sub_win, COLOR_PAIR (SVETLEM));
      mvwprintw (sub_win, 10, 4, "Semestrů je: %d.",SEMESTRU);
      mvwprintw8 (sub_win, 11, 4, L"%-25s",
         "Zadejte SEMESTR, do kterého předmět patří: ");
      wattroff (sub_win, COLOR_PAIR (SVETLEM));
      wclrtoeol (sub_win);
      box (sub_win, HORZ, VERT);
      wrefresh (sub_win);
      if(0 >= wscanw (sub_win, "%i", &pomocny.semestr))
      {
        pomocny.semestr = -1;
      }
    }
  while (pomocny.semestr < 1 || pomocny.semestr > SEMESTRU);


  do
    {
      wattron (sub_win, COLOR_PAIR (SVETLEM));
      mvwprintw (sub_win, 12, 4, "%s",
         "Zadejte semestr, ve kterém byl předmět UKONČEN");
      if(!pomocny.znamka)
          mvwprintw (sub_win, 13, 4, "%-25s", "(0= předmět nebyl ukončen): ");
      else
          mvwprintw (sub_win, 13, 4, "%-25s", "(známkovaný předmět musí být ukončen): ");
      wattroff (sub_win, COLOR_PAIR (SVETLEM));
      wclrtoeol (sub_win);
      box (sub_win, HORZ, VERT);
      wrefresh (sub_win);
      wscanw (sub_win, "%i", &pomocny.vsemestru);
    }
  while ((pomocny.vsemestru < 0 || pomocny.vsemestru > SEMESTRU) ||
     (!pomocny.vsemestru && pomocny.znamka));

  noecho ();
  mvwprintw8 (sub_win, 15, 2, L"%4s %-40s %5s %5s %6s %6s", "kód:", "Název",
         "sem.", "ukon.", "kredit", "známka");

  mvwprintw8 (sub_win, 16, 2, L"%4s %-40s %5i %5i %6i %6i", pomocny.kod,
         pomocny.nazev, pomocny.semestr, pomocny.vsemestru,
         pomocny.kreditu, pomocny.znamka);

  do
    {
      wattron (sub_win, COLOR_PAIR (CERVENA));
      mvwprintw (sub_win, 18, 2, "Je zaznam v pořádku? [Ano/Ne/Konec]");
      wattroff (sub_win, COLOR_PAIR (CERVENA));
      wrefresh (sub_win);

      switch (getch ())
    {
    case 'n':
    case 'N':
      goto znovu;
      break;
    case 'a':
    case 'A':
      zaznamenej (pomocny, dbm_ptr);
      return;
      break;
    case 'k':
    case 'K':
      delwin (sub_win);
      return;
      break;
    }
    }
  while (1);

}
